// ParameterizedDlg.h : header file
//

#pragma once
#include "afxcmn.h"


// CParameterizedDlg dialog
class CParameterizedDlg : public CDialog
{
// Construction
public:
	CParameterizedDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_PARAMETERIZED_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

protected:
 void ShowPermissions();
 void ExpandAllBranches();
 void ExpandBranch(HTREEITEM hItem, BOOL bExpand = TRUE);

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnBnClickedButton1();
  CString m_strUserID;
  CString m_strUserName;
  int m_iStatus;
  CTreeCtrl m_treePermissions;
  afx_msg void OnBnClickedOk();
  int m_iUseWildcards;
};
