// PermissionsQry.h : Implementation of the CPermissionsQry class

#include "stdafx.h"
#include "PermissionsQry.h"
IMPLEMENT_DYNAMIC(CPermissionsQry, CRecordset)

CPermissionsQry::CPermissionsQry(CDatabase* pdb)
	: CRecordset(pdb)
{
	m_sCompanyID = L"";
	m_sCompanyName = L"";
	m_sSubsystemID = L"";
	m_sSubsystemName = L"";
	m_nFields = 4;
	m_nDefaultType = dynaset;

  m_sUserIDParam = _T("");
  m_nParams = 1;
}

CString CPermissionsQry::GetDefaultConnect()
{
	return _T("DSN=VCNet Bible;DBQ=C:\\books\\VCNetBible\\Database\\VCNETBible.mdb;DriverId=25;FIL=MS Access;MaxBufferSize=2048;PageTimeout=5;UID=admin;");
}

CString CPermissionsQry::GetDefaultSQL()
{
	return _T("{CALL GetPermissionsByUserID(?)}");
}

void CPermissionsQry::DoFieldExchange(CFieldExchange* pFX)
{
	pFX->SetFieldType(CFieldExchange::outputColumn);
// Macros such as RFX_Text() and RFX_Int() are dependent on the
// type of the member variable, not the type of the field in the database.
// ODBC will try to automatically convert the column value to the requested type
	RFX_Text(pFX, _T("[sCompanyID]"), m_sCompanyID);
	RFX_Text(pFX, _T("[sCompanyName]"), m_sCompanyName);
	RFX_Text(pFX, _T("[sSubsystemID]"), m_sSubsystemID);
	RFX_Text(pFX, _T("[sSubsystemName]"), m_sSubsystemName);

  pFX->SetFieldType(CFieldExchange::param);
  RFX_Text(pFX, _T("[sUserID]"), m_sUserIDParam);
}
/////////////////////////////////////////////////////////////////////////////
// CPermissionsQry diagnostics

#ifdef _DEBUG
void CPermissionsQry::AssertValid() const
{
	CRecordset::AssertValid();
}

void CPermissionsQry::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG


