// UserMaintenanceDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "User.h"

// CUserMaintenanceDlg dialog
class CUserMaintenanceDlg : public CDialog
{
// Construction
public:
	CUserMaintenanceDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_USERMAINTENANCE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

protected:
  void FillListboxWithUsers();
  BOOL GetSelectedUser(int* piIndex, CUser** ppUser);
  void InitControls();
  BOOL SaveUser(CUser* pUser);
  BOOL DeleteUser(CUser* pUser);

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnBnClickedButton4();
  CListBox m_lbxUsers;
  CString m_strUserID;
  CString m_strUserName;
  int m_iStatus;
  CButton m_btnSave;
  CButton m_btnDelete;
  CButton m_btnClose;
  afx_msg void OnLbnSelchangeList1();
  afx_msg void OnBnClickedOk();
  afx_msg void OnBnClickedButton2();
  virtual BOOL DestroyWindow();
};
